commit 66128169c25ac1ff4a64532420de38645614102f
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Sun Mar 7 19:10:36 2010 +0100

    [fix] broken translation + refresh

diff --git a/bin/postman b/bin/postman
index 3680d13..1a01e90 100755
--- a/bin/postman
+++ b/bin/postman
@@ -281,7 +281,7 @@ module CyborgHood
 
               dom = CyborgHood::DnsDomain.new(zone)
               unless dom.hosted?
-                result.message = ("This zone is not hosted here.")
+                result.message = _("This zone is not hosted here.")
                 return result
               end
               unless dom.managed_by? user
diff --git a/po/cyborghood.pot b/po/cyborghood.pot
index 4ab89be..46b8a1e 100644
--- a/po/cyborghood.pot
+++ b/po/cyborghood.pot
@@ -7,7 +7,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2009-03-10 01:23+0100\n"
+"POT-Creation-Date: 2010-03-07 19:04+0100\n"
 "PO-Revision-Date: 2009-03-07 21:38+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -16,13 +16,17 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: lib/cyborghood/mail.rb:190
+#: lib/cyborghood/order.rb:57
+msgid "Syntax error in command."
+msgstr ""
+
+#: lib/cyborghood/mail.rb:189
 msgid ""
 "The signature was made too long ago (check your system clock). Rejected "
 "message to avoid replay attacks."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:194
+#: lib/cyborghood/mail.rb:193
 msgid ""
 "The signature was made in the future (check your system clock). Rejected "
 "message to avoid replay attacks."
diff --git a/po/cyborghood_postman.pot b/po/cyborghood_postman.pot
index 04cff39..8f9bacb 100644
--- a/po/cyborghood_postman.pot
+++ b/po/cyborghood_postman.pot
@@ -7,7 +7,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2009-03-10 01:23+0100\n"
+"POT-Creation-Date: 2010-03-07 19:04+0100\n"
 "PO-Revision-Date: 2009-03-07 21:38+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -16,75 +16,75 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: /opt/cyborghood-dev/bin/postman:148 /opt/cyborghood-dev/bin/postman:164
-#: /opt/cyborghood-dev/bin/postman:177
+#: /opt/cyborghood-dev/bin/postman:143 /opt/cyborghood-dev/bin/postman:159
+#: /opt/cyborghood-dev/bin/postman:173
 msgid "Hello %s,"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:148
+#: /opt/cyborghood-dev/bin/postman:143
 msgid "Hello,"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:150
+#: /opt/cyborghood-dev/bin/postman:145
 msgid ""
 "A message (ID: %s), apparently from you, was rejected for the following "
 "reason:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:165
+#: /opt/cyborghood-dev/bin/postman:160
 msgid ""
 "An order, in a message (ID: %s) from you, was rejected for the following "
 "reason:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:178
+#: /opt/cyborghood-dev/bin/postman:174
 msgid "Follows the transcript of your commands:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:227
+#: /opt/cyborghood-dev/bin/postman:223
 msgid "Contact eMail:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:228
+#: /opt/cyborghood-dev/bin/postman:224
 msgid "Contact URL:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:247
-msgid "Command not recognized."
-msgstr ""
-
-#: /opt/cyborghood-dev/bin/postman:261 /opt/cyborghood-dev/bin/postman:380
+#: /opt/cyborghood-dev/bin/postman:247 /opt/cyborghood-dev/bin/postman:356
 msgid "Internal error. Administrator is warned."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:298
+#: /opt/cyborghood-dev/bin/postman:274
 msgid "You are manager of the following zones: %s."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:312 /opt/cyborghood-dev/bin/postman:334
-msgid "You are not allowed to manage this zone."
+#: /opt/cyborghood-dev/bin/postman:284 /opt/cyborghood-dev/bin/postman:306
+msgid "This zone is not hosted here."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:318
-msgid "Requested zone content attached."
+#: /opt/cyborghood-dev/bin/postman:288 /opt/cyborghood-dev/bin/postman:310
+msgid "You are not allowed to manage this zone."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:330
-msgid "This zone is not hosted here."
+#: /opt/cyborghood-dev/bin/postman:294
+msgid "Requested zone content attached."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:343
+#: /opt/cyborghood-dev/bin/postman:319
 msgid "Attachment has wrong content-type."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:358
+#: /opt/cyborghood-dev/bin/postman:334
 msgid "Invalid zone data."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:365
+#: /opt/cyborghood-dev/bin/postman:341
 msgid "Zone serial is not superior to current serial."
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:376
+#: /opt/cyborghood-dev/bin/postman:352
 msgid "Zone updated."
 msgstr ""
+
+#: /opt/cyborghood-dev/bin/postman:370
+msgid "Command not recognized."
+msgstr ""
diff --git a/po/fr/cyborghood.po b/po/fr/cyborghood.po
index aa6e0d2..17d4896 100644
--- a/po/fr/cyborghood.po
+++ b/po/fr/cyborghood.po
@@ -7,7 +7,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2009-03-10 01:23+0100\n"
+"POT-Creation-Date: 2010-03-07 19:04+0100\n"
 "PO-Revision-Date: 2009-03-07 20:59+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
@@ -15,7 +15,11 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=1; plural=(n != 1);\n"
 
-#: lib/cyborghood/mail.rb:190
+#: lib/cyborghood/order.rb:57
+msgid "Syntax error in command."
+msgstr ""
+
+#: lib/cyborghood/mail.rb:189
 msgid ""
 "The signature was made too long ago (check your system clock). Rejected "
 "message to avoid replay attacks."
@@ -23,7 +27,7 @@ msgstr ""
 "La signature a été faite depuis trop longtemps (vérifiez votre horloge "
 "système. Message rejeté pour éviter les attaques par rejeux."
 
-#: lib/cyborghood/mail.rb:194
+#: lib/cyborghood/mail.rb:193
 msgid ""
 "The signature was made in the future (check your system clock). Rejected "
 "message to avoid replay attacks."
diff --git a/po/fr/cyborghood_postman.po b/po/fr/cyborghood_postman.po
index 390fde3..24c0374 100644
--- a/po/fr/cyborghood_postman.po
+++ b/po/fr/cyborghood_postman.po
@@ -7,7 +7,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2009-03-10 01:23+0100\n"
+"POT-Creation-Date: 2010-03-07 19:04+0100\n"
 "PO-Revision-Date: 2009-03-07 21:27+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
@@ -15,16 +15,16 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=1; plural=(n != 1);\n"
 
-#: /opt/cyborghood-dev/bin/postman:148 /opt/cyborghood-dev/bin/postman:164
-#: /opt/cyborghood-dev/bin/postman:177
+#: /opt/cyborghood-dev/bin/postman:143 /opt/cyborghood-dev/bin/postman:159
+#: /opt/cyborghood-dev/bin/postman:173
 msgid "Hello %s,"
 msgstr "Bonjour %s,"
 
-#: /opt/cyborghood-dev/bin/postman:148
+#: /opt/cyborghood-dev/bin/postman:143
 msgid "Hello,"
 msgstr "Bonjour,"
 
-#: /opt/cyborghood-dev/bin/postman:150
+#: /opt/cyborghood-dev/bin/postman:145
 msgid ""
 "A message (ID: %s), apparently from you, was rejected for the following "
 "reason:"
@@ -32,7 +32,7 @@ msgstr ""
 "Un message (ID: %s), provenant apparemment de vous, a été rejeté pour la "
 "raison suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:165
+#: /opt/cyborghood-dev/bin/postman:160
 msgid ""
 "An order, in a message (ID: %s) from you, was rejected for the following "
 "reason:"
@@ -40,54 +40,54 @@ msgstr ""
 "Un order, dans in message (ID: %s) venant de vous, a été rejeté pour la "
 "raison suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:178
+#: /opt/cyborghood-dev/bin/postman:174
 msgid "Follows the transcript of your commands:"
 msgstr "La retranscription des commandes suit :"
 
-#: /opt/cyborghood-dev/bin/postman:227
+#: /opt/cyborghood-dev/bin/postman:223
 msgid "Contact eMail:"
 msgstr "eMail de Contact :"
 
-#: /opt/cyborghood-dev/bin/postman:228
+#: /opt/cyborghood-dev/bin/postman:224
 msgid "Contact URL:"
 msgstr "URL de Contact :"
 
-#: /opt/cyborghood-dev/bin/postman:247
-msgid "Command not recognized."
-msgstr "Commande non reconnue"
-
-#: /opt/cyborghood-dev/bin/postman:261 /opt/cyborghood-dev/bin/postman:380
+#: /opt/cyborghood-dev/bin/postman:247 /opt/cyborghood-dev/bin/postman:356
 msgid "Internal error. Administrator is warned."
 msgstr "Erreur interne. L'administrateur a été prévenu."
 
-#: /opt/cyborghood-dev/bin/postman:298
+#: /opt/cyborghood-dev/bin/postman:274
 msgid "You are manager of the following zones: %s."
 msgstr "Vous gérez les zones suivantes : %s."
 
-#: /opt/cyborghood-dev/bin/postman:312 /opt/cyborghood-dev/bin/postman:334
+#: /opt/cyborghood-dev/bin/postman:284 /opt/cyborghood-dev/bin/postman:306
+msgid "This zone is not hosted here."
+msgstr "Cette zone n'est pas hébergée ici."
+
+#: /opt/cyborghood-dev/bin/postman:288 /opt/cyborghood-dev/bin/postman:310
 msgid "You are not allowed to manage this zone."
 msgstr "Vous n'êtes pas autorisé à gérer cette zone."
 
-#: /opt/cyborghood-dev/bin/postman:318
+#: /opt/cyborghood-dev/bin/postman:294
 msgid "Requested zone content attached."
 msgstr "Le contenu de la zone demandée est en pièce jointe."
 
-#: /opt/cyborghood-dev/bin/postman:330
-msgid "This zone is not hosted here."
-msgstr "Cette zone n'est pas hébergée ici."
-
-#: /opt/cyborghood-dev/bin/postman:343
+#: /opt/cyborghood-dev/bin/postman:319
 msgid "Attachment has wrong content-type."
 msgstr "La pièce jointe a un mauvais type de contenu (content-type)."
 
-#: /opt/cyborghood-dev/bin/postman:358
+#: /opt/cyborghood-dev/bin/postman:334
 msgid "Invalid zone data."
 msgstr "Données pour la zone invalides."
 
-#: /opt/cyborghood-dev/bin/postman:365
+#: /opt/cyborghood-dev/bin/postman:341
 msgid "Zone serial is not superior to current serial."
 msgstr "Le numéro de série de la zone n'est pas supèrieur à celui actuel."
 
-#: /opt/cyborghood-dev/bin/postman:376
+#: /opt/cyborghood-dev/bin/postman:352
 msgid "Zone updated."
 msgstr "Zone mise à jour."
+
+#: /opt/cyborghood-dev/bin/postman:370
+msgid "Command not recognized."
+msgstr "Commande non reconnue"