commit e731525947e6d996a5133bad7def623d0199a24f
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Sun Apr 4 18:33:05 2010 +0200

    [licence] updated copyright years and added missing headers

diff --git a/bin/guard b/bin/guard
index 817d5c4..b6d8d1d 100755
--- a/bin/guard
+++ b/bin/guard
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/bin/postman b/bin/postman
index b878816..2b46d47 100755
--- a/bin/postman
+++ b/bin/postman
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/bin/postman_daemon b/bin/postman_daemon
index 45ae3c3..13abe8c 100755
--- a/bin/postman_daemon
+++ b/bin/postman_daemon
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood.rb b/lib/cyborghood.rb
index 22969b7..1f0a108 100644
--- a/lib/cyborghood.rb
+++ b/lib/cyborghood.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/config.rb b/lib/cyborghood/base/config.rb
index 2fd3c38..6d174d8 100644
--- a/lib/cyborghood/base/config.rb
+++ b/lib/cyborghood/base/config.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/exceptions.rb b/lib/cyborghood/base/exceptions.rb
index fefe96c..c029781 100644
--- a/lib/cyborghood/base/exceptions.rb
+++ b/lib/cyborghood/base/exceptions.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/info.rb b/lib/cyborghood/base/info.rb
index 4f20b3d..5ff552f 100644
--- a/lib/cyborghood/base/info.rb
+++ b/lib/cyborghood/base/info.rb
@@ -1,3 +1,21 @@
+#--
+# CyborgHood, a distributed system management software.
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
+
 module CyborgHood
   PRODUCT = "CyborgHood"
   VERSION = "0.2.0"
diff --git a/lib/cyborghood/base/lang_additions.rb b/lib/cyborghood/base/lang_additions.rb
index efbff3b..9483fa0 100644
--- a/lib/cyborghood/base/lang_additions.rb
+++ b/lib/cyborghood/base/lang_additions.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/language.rb b/lib/cyborghood/base/language.rb
index 36375bd..f493082 100644
--- a/lib/cyborghood/base/language.rb
+++ b/lib/cyborghood/base/language.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/logger.rb b/lib/cyborghood/base/logger.rb
index 85a0985..4b8e48e 100644
--- a/lib/cyborghood/base/logger.rb
+++ b/lib/cyborghood/base/logger.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/command_runner.rb b/lib/cyborghood/command_runner.rb
index 76b17ff..dc9d298 100644
--- a/lib/cyborghood/command_runner.rb
+++ b/lib/cyborghood/command_runner.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg.rb b/lib/cyborghood/cyborg.rb
index 3d89656..255978e 100644
--- a/lib/cyborghood/cyborg.rb
+++ b/lib/cyborghood/cyborg.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/imap.rb b/lib/cyborghood/imap.rb
index b8c33c5..9c87919 100644
--- a/lib/cyborghood/imap.rb
+++ b/lib/cyborghood/imap.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/mail.rb b/lib/cyborghood/mail.rb
index fddacf1..aed9a30 100644
--- a/lib/cyborghood/mail.rb
+++ b/lib/cyborghood/mail.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/mail_order.rb b/lib/cyborghood/mail_order.rb
index 8194355..3a233c3 100644
--- a/lib/cyborghood/mail_order.rb
+++ b/lib/cyborghood/mail_order.rb
@@ -1,3 +1,21 @@
+#--
+# CyborgHood, a distributed system management software.
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
+
 require 'cyborghood/order'
 
 module CyborgHood
diff --git a/lib/cyborghood/objects.rb b/lib/cyborghood/objects.rb
index ccbdb36..c9373f7 100644
--- a/lib/cyborghood/objects.rb
+++ b/lib/cyborghood/objects.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/objects/ldap.rb b/lib/cyborghood/objects/ldap.rb
index ac84305..161032c 100644
--- a/lib/cyborghood/objects/ldap.rb
+++ b/lib/cyborghood/objects/ldap.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/order.rb b/lib/cyborghood/order.rb
index 895baf9..ee92ce8 100644
--- a/lib/cyborghood/order.rb
+++ b/lib/cyborghood/order.rb
@@ -1,3 +1,21 @@
+#--
+# CyborgHood, a distributed system management software.
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
+
 module CyborgHood
   class Command
     attr_reader :cmdline, :cmdsplit, :parsing_errors
diff --git a/lib/cyborghood/services/dns.rb b/lib/cyborghood/services/dns.rb
index 9afc811..66516cc 100644
--- a/lib/cyborghood/services/dns.rb
+++ b/lib/cyborghood/services/dns.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/tmail_gpg.rb b/lib/tmail_gpg.rb
index 568fd2e..c314d15 100644
--- a/lib/tmail_gpg.rb
+++ b/lib/tmail_gpg.rb
@@ -1,5 +1,5 @@
 #--
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the
diff --git a/po/fr/cyborghood.po b/po/fr/cyborghood.po
index 4314041..8387b0f 100644
--- a/po/fr/cyborghood.po
+++ b/po/fr/cyborghood.po
@@ -1,7 +1,7 @@
 # CyborgHood
-# Copyright (C) 2009 DuckCorp
+# Copyright (C) 2009-2010 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
-# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009.
+# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
 #
 #, fuzzy
 msgid ""
diff --git a/po/fr/cyborghood_postman.po b/po/fr/cyborghood_postman.po
index b6db50d..2570186 100644
--- a/po/fr/cyborghood_postman.po
+++ b/po/fr/cyborghood_postman.po
@@ -1,7 +1,7 @@
 # CyborgHood
-# Copyright (C) 2009 DuckCorp
+# Copyright (C) 2009-2010 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
-# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009.
+# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
 #
 #, fuzzy
 msgid ""
diff --git a/post-clean.rb b/post-clean.rb
index 4aa5b81..a47cb6d 100644
--- a/post-clean.rb
+++ b/post-clean.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/post-config.rb b/post-config.rb
index 47732ca..71d7e48 100644
--- a/post-config.rb
+++ b/post-config.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,7 @@ header = <<HEADER
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/post-setup.rb b/post-setup.rb
index ed3db8a..591e679 100644
--- a/post-setup.rb
+++ b/post-setup.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by